rm(list=ls())
library(mkin)
sourceDir <- function(path, trace = TRUE, ...) {
    for (nm in list.files(path, pattern = "\\.[RrSsQq]$")) {
       if(trace) cat(nm,":")
       source(file.path(path, nm), ...)
       if(trace) cat("\n")
    }
 }
## Need to be edited
sourceDir('S:/Projects/ongoing/Gao/Kinetics/KINGUII/KINGUI/Sourcefunctions/')
#sourceDir('M:/Projects/Kinetics/KINGUII/KINGUI/Sourcefunctions/')

### Read in data ###

###################
## KinGUI II VERSION
####################

test1 <- mkinmod.gui(parent = list(type = "SFO",
                     to = c("M1"),
                     k = list(ini   = 0.1,
                     fixed = 0,
                     lower = 0,
                     upper = Inf),
                     M0 = list(ini   = 100,
                     fixed = 0,
                     lower = 0,
                     upper = Inf),
                     FF = list(ini   = c(0.5),
                     fixed = c(0),
                     lower = c(0),
                     upper = c(1)),
                     sink  = TRUE,
                     time =c(0,1,2,4,8,14,28,56,91,120),
                     residue = c(100.00 , 84.46 , 71.48 , 51.56 , 27.61 , 11.65 , 2.08 , 0.11 , 0.00 , 0.00),
                     weight = c(1,1,1,1,1,1,1,1,1,1)),
                     M1     = list(type = "SFO",
                     k  = list(ini   = 0.6,
                     fixed = 0,
                     lower = 0,
                     upper = Inf),
                     residue = c(0.00 , 5.79 , 8.01 , 8.01 , 4.71 , 1.80 , 0.25 , 0.01 , 0.00 , 0.00 ),
                     weight = c(1,1,1,1,1,1,1,1,1,1)))


fit0 <- mkinfit.gui(test1,eigen=FALSE,plot= TRUE,plottitle='Haha',quiet= TRUE,ctr=kingui.control(method='Marq',maxIter=10,tolerance=1e-3,odesolver='lsoda'))
fit2 <- IRLSkinfit.gui(test1,eigen=FALSE,plot= TRUE,plottitle='Haha',quiet= FALSE,ctr=kingui.control(method='Marq',maxIter=10,tolerance=1e-3,odesolver='lsoda'))
kingraph(fit0,'g.txt')
list2ascii(summary(fit0),file='ouput1.txt')
list2ascii(summary(fit0,cov=TRUE),file='ouput2.txt')
