###################################################
### chunk number 1: preliminaries
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
library("FME")
options(prompt = "> ")
options(width=70)


###################################################
### chunk number 2: 
###################################################
#line 194 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
mu  <- 10
std <- 1

Nfun <- function(p)
  -2*log(dnorm(p,mean=mu,sd=std))


###################################################
### chunk number 3: 
###################################################
#line 207 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC <- modMCMC (f=Nfun, p=9.5, niter=2000, jump=5)


###################################################
### chunk number 4: 
###################################################
#line 212 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC <- modMCMC (f=Nfun, p=9.5, niter=2000, jump=5, updatecov=10)
summary(MCMC)


###################################################
### chunk number 5: 
###################################################
#line 220 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC2 <- modMCMC (f=Nfun, p=9.5, lower=9, niter=2000, jump=5,
  updatecov=10)
summary(MCMC2)


###################################################
### chunk number 6: 
###################################################
#line 232 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
pri <- function(p) -2*log(dnorm(p,8,1))
MCMC3 <- modMCMC (f=Nfun,p=9.5,niter=2000,jump=5,
  updatecov=10,prior=pri)
summary(MCMC3)


###################################################
### chunk number 7: 
###################################################
#line 241 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
summary(MCMC4<-modMCMC(f=Nfun,p=1,niter=2000,jump=5,
  updatecov=10,prior=pri,ntrydr=2))

MCMC4$count


###################################################
### chunk number 8: hist1
###################################################
#line 250 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
par(mfrow=c(2,2))
hist(MCMC$pars,xlab="x",freq=FALSE,main="unconstrained",xlim=c(6,14))
hist(MCMC2$pars,xlab="x",freq=FALSE,main="x>9",xlim=c(6,14))
hist(MCMC3$pars,xlab="x",freq=FALSE,main="pri(x)~N(8,1)",xlim=c(6,14))
plot(MCMC3,mfrow=NULL,main="AM")
mtext(outer=TRUE,line=-1.5,"N(10,1)",cex=1.25)


###################################################
### chunk number 9: hist1
###################################################
#line 261 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 250 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#261#"
par(mfrow=c(2,2))
hist(MCMC$pars,xlab="x",freq=FALSE,main="unconstrained",xlim=c(6,14))
hist(MCMC2$pars,xlab="x",freq=FALSE,main="x>9",xlim=c(6,14))
hist(MCMC3$pars,xlab="x",freq=FALSE,main="pri(x)~N(8,1)",xlim=c(6,14))
plot(MCMC3,mfrow=NULL,main="AM")
mtext(outer=TRUE,line=-1.5,"N(10,1)",cex=1.25)
#line 262 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 10: 
###################################################
#line 278 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
mu  <- 1:4
std <- 1

NL <- function(p)  {
  -2*sum(log(dlnorm(p,mean=mu,sd=std)))
}


###################################################
### chunk number 11: 
###################################################
#line 290 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMCl <- modMCMC (f=NL, p=rep(1,4), niter=10000,
  outputlength=1000, jump=5)


###################################################
### chunk number 12: logp1
###################################################
#line 296 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMCl)


###################################################
### chunk number 13: logp1
###################################################
#line 302 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 296 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#302#"
plot(MCMCl)
#line 303 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 14: 
###################################################
#line 314 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMCl <- modMCMC (f=NL,p=rep(1,4),niter=5000,outputlength=1000,
         jump=5, updatecov=100, ntrydr=2)


###################################################
### chunk number 15: logp
###################################################
#line 319 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMCl)


###################################################
### chunk number 16: logp
###################################################
#line 325 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 319 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#325#"
plot(MCMCl)
#line 326 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 17: hist
###################################################
#line 333 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
hist(MCMCl)


###################################################
### chunk number 18: hist
###################################################
#line 339 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 333 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#339#"
hist(MCMCl)
#line 340 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 19: 
###################################################
#line 346 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMCl$pars <- log(MCMCl$pars)
summary(MCMCl)


###################################################
### chunk number 20: 
###################################################
#line 376 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Banana <- function (x1,x2) {
  return(x2 - (x1^2+1))
}


###################################################
### chunk number 21: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
pmultinorm <- function(vec,mean,Cov) {
  diff <- vec - mean
  ex   <- -0.5*t(diff) %*% solve(Cov) %*% diff
  rdet   <- sqrt(det(Cov))
  power  <- -length(diff)*0.5
  return((2.*pi)^power / rdet * exp(ex))
}


###################################################
### chunk number 22: 
###################################################
#line 395 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
BananaSS <- function (p)
{
  P <- c(p[1],Banana(p[1],p[2]))
  Cov <- matrix(nr=2,data=c(1,0.9,0.9,1))
 -2*sum(log(pmultinorm(P,mean=0,Cov=Cov)))
}


###################################################
### chunk number 23: 
###################################################
#line 413 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC <- modMCMC(f=BananaSS, p=c(0,0.5), jump=diag(nrow=2,x=5),
                niter=2000)
MCMC$count


###################################################
### chunk number 24: 
###################################################
#line 423 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC2 <- modMCMC(f=BananaSS, p=c(0,0.5), jump=diag(nrow=2,x=5),
                 updatecov=100,niter=2000)
MCMC2$count


###################################################
### chunk number 25: 
###################################################
#line 433 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC3 <- modMCMC(f=BananaSS, p=c(0,0.5), jump=diag(nrow=2,x=5),
                 ntrydr=2,niter=2000)
MCMC3$count


###################################################
### chunk number 26: 
###################################################
#line 445 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
print(system.time(
MCMC4 <- modMCMC(f=BananaSS, p=c(0,0.5), jump=diag(nrow=2,x=5),
                 updatecov=100,ntrydr=2,niter=2000)
))
MCMC4$count


###################################################
### chunk number 27: banana
###################################################
#line 456 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
par(mfrow=c(4,2))
par(mar=c(2,2,4,2))
plot(MCMC ,mfrow=NULL,main="MH")
plot(MCMC2,mfrow=NULL,main="AM")
plot(MCMC3,mfrow=NULL,main="DR")
plot(MCMC4,mfrow=NULL,main="DRAM")
mtext(outer=TRUE,side=3,line=-2,at=c(0.05,0.95),c("y1","y2"),cex=1.25)
par(mar=c(5.1,4.1,4.1,2.1))


###################################################
### chunk number 28: banana2
###################################################
#line 467 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
par(mfrow=c(2,2))
xl <- c(-3,3)
yl <- c(-1,8)
plot(MCMC$pars,main="MH",xlim=xl,ylim=yl)
plot(MCMC2$pars,main="AM",xlim=xl,ylim=yl)
plot(MCMC3$pars,main="DR",xlim=xl,ylim=yl)
plot(MCMC4$pars,main="DRAM",xlim=xl,ylim=yl)


###################################################
### chunk number 29: banana2
###################################################
#line 479 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 467 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#479#"
par(mfrow=c(2,2))
xl <- c(-3,3)
yl <- c(-1,8)
plot(MCMC$pars,main="MH",xlim=xl,ylim=yl)
plot(MCMC2$pars,main="AM",xlim=xl,ylim=yl)
plot(MCMC3$pars,main="DR",xlim=xl,ylim=yl)
plot(MCMC4$pars,main="DRAM",xlim=xl,ylim=yl)
#line 480 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 30: 
###################################################
#line 489 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
trans <- cbind(MCMC4$pars[,1],Banana(MCMC4$pars[,1],MCMC4$pars[,2]))
colMeans(trans)    # was:c(0,0)
sd(trans)          # was:1
cov(trans)         # 0.9 off-diagonal


###################################################
### chunk number 31: 
###################################################
#line 522 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Reaction <- function (k, times)
{
  fac <- k[1]/(k[1]+k[2])
  A   <- fac + (1-fac)*exp(-(k[1]+k[2])*times)
  return(data.frame(t=times,A=A))
}


###################################################
### chunk number 32: 
###################################################
#line 532 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Data     <- data.frame(
  times = c(2,     4,     6,     8,     10   ),
  A     = c(0.661, 0.668, 0.663, 0.682, 0.650))
Data


###################################################
### chunk number 33: 
###################################################
#line 544 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Prior <- function(p)
    return( sum(((p-c(2,4))/200)^2 ))


###################################################
### chunk number 34: 
###################################################
#line 551 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
residual <- function(k) return(Data$A - Reaction(k,Data$times)$A)

Fit <- modFit(p=c(k1=0.5,k2=0.5), f=residual, lower=c(0,0), upper=c(1,1))
(sF <- summary(Fit))


###################################################
### chunk number 35: 
###################################################
#line 572 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
mse <- sF$modVariance
Cov <- sF$cov.scaled * 2.4^2/2

print(system.time(
MCMC <- modMCMC(f=residual, p=Fit$par, jump=Cov, lower=c(0,0),
                var0=mse, wvar0=1, prior=Prior, niter=5000)
))


###################################################
### chunk number 36: ABMCMC
###################################################
#line 585 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMC,Full=TRUE)


###################################################
### chunk number 37: ABMCMC
###################################################
#line 591 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 585 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#591#"
plot(MCMC,Full=TRUE)
#line 592 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 38: 
###################################################
#line 601 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
MCMC2<- modMCMC(f=residual, p=Fit$par, jump=Cov, updatecov=100, lower=c(0,0),
                var0=mse, wvar0=1, prior=Prior,niter=5000)    #


###################################################
### chunk number 39: ABMCMC2
###################################################
#line 605 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMC2,Full=TRUE)


###################################################
### chunk number 40: ABMCMC2
###################################################
#line 611 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 605 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#611#"
plot(MCMC2,Full=TRUE)
#line 612 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 41: ABMCMC3
###################################################
#line 621 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
pairs(MCMC2)


###################################################
### chunk number 42: ABMCMC3
###################################################
#line 627 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 621 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#627#"
pairs(MCMC2)
#line 628 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 43: 
###################################################
#line 639 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
sR <- sensRange(f=Reaction,times=seq(0,10,0.1),parInput=MCMC2$pars)


###################################################
### chunk number 44: sr
###################################################
#line 643 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(summary(sR),xlab="time",ylab="Conc")
points(Data)


###################################################
### chunk number 45: sr
###################################################
#line 650 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 643 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#650#"
plot(summary(sR),xlab="time",ylab="Conc")
points(Data)
#line 651 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 46: 
###################################################
#line 676 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Obs <- data.frame(x=c(   28,  55,   83,  110,  138,  225,  375),   # mg COD/l
                  y=c(0.053,0.06,0.112,0.105,0.099,0.122,0.125))   # 1/hour

Obs2<- data.frame(x=c(   20,  55,   83,  110,  138,  240,  325),   # mg COD/l
                   y=c(0.05,0.07,0.09,0.10,0.11,0.122,0.125))   # 1/hour



###################################################
### chunk number 47: 
###################################################
#line 687 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Model <- function(p,x) return(data.frame(x=x,y=p[1]*x/(x+p[2])))


###################################################
### chunk number 48: 
###################################################
#line 696 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Residuals  <- function(p) {
   cost<-modCost(model=Model(p,Obs$x),obs=Obs,x="x")
   modCost(model=Model(p,Obs2$x),obs=Obs2,cost=cost,x="x")
}


###################################################
### chunk number 49: 
###################################################
#line 704 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
print(system.time(
P      <- modFit(f=Residuals,p=c(0.1,1))
))


###################################################
### chunk number 50: obs
###################################################
#line 710 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(Obs,xlab="mg COD/l",ylab="1/hour", pch=16, cex=1.5)
points(Obs2,pch=18,cex=1.5, col="red")
lines(Model(p=P$par,x=0:375))


###################################################
### chunk number 51: obs
###################################################
#line 718 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 710 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#718#"
plot(Obs,xlab="mg COD/l",ylab="1/hour", pch=16, cex=1.5)
points(Obs2,pch=18,cex=1.5, col="red")
lines(Model(p=P$par,x=0:375))
#line 719 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 52: 
###################################################
#line 731 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
Covar   <- summary(P)$cov.scaled * 2.4^2/2


###################################################
### chunk number 53: 
###################################################
#line 747 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
s2prior <- P$ms

print(system.time(
MCMC <- modMCMC(f=Residuals,p=P$par,jump=Covar,niter=1000,
                var0=s2prior,wvar0=0.1,lower=c(0,0))
))


###################################################
### chunk number 54: Monmcmc
###################################################
#line 757 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMC,Full=TRUE)


###################################################
### chunk number 55: Monmcmc
###################################################
#line 763 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 757 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#763#"
plot(MCMC,Full=TRUE)
#line 764 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 56: 
###################################################
#line 776 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
varprior <- P$var_ms_unweighted

print(system.time(
MCMC2 <- modMCMC(f=Residuals,p=P$par,jump=Covar,niter=1000,
                var0=varprior,wvar0=0.1,lower=c(0,0))
))


###################################################
### chunk number 57: Monmcmc2
###################################################
#line 787 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
plot(MCMC2,Full=TRUE,which=NULL)


###################################################
### chunk number 58: Monmcmc2
###################################################
#line 793 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
#line 787 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw#from line#793#"
plot(MCMC2,Full=TRUE,which=NULL)
#line 794 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"


###################################################
### chunk number 59: 
###################################################
#line 801 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEmcmc.Rnw"
summary(MCMC)
summary(MCMC2)


