###################################################
### chunk number 1: preliminaries
###################################################
#line 87 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
library("FME")
options(prompt = "> ")
options(width=70)


###################################################
### chunk number 2: 
###################################################
#line 112 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
require(FME)


###################################################
### chunk number 3: 
###################################################
#line 116 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
Obs <- data.frame(x=c(   28,  55,   83,  110,  138,  225,  375),   # mg COD/l
                  y=c(0.053,0.06,0.112,0.105,0.099,0.122,0.125))   # 1/hour


###################################################
### chunk number 4: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
Model <- function(p,x) return(data.frame(x=x,y=p[1]*x/(x+p[2])))


###################################################
### chunk number 5: 
###################################################
#line 129 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
Residuals  <- function(p) (Obs$y-Model(p,Obs$x)$y)


###################################################
### chunk number 6: 
###################################################
#line 134 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
print(system.time(
P      <- modFit(f=Residuals,p=c(0.1,1))
))


###################################################
### chunk number 7: 
###################################################
#line 141 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
sP    <- summary(P)
sP


###################################################
### chunk number 8: 
###################################################
#line 147 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
x      <-0:375


###################################################
### chunk number 9: Monplot
###################################################
#line 150 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
par(mfrow=c(2,2))
plot(P,mfrow=NULL)
plot(Obs,pch=16,cex=2,xlim=c(0,400),ylim=c(0,0.15),
     xlab="mg COD/l",ylab="1/hr",main="best-fit")
lines(Model(P$par,x))
par(mfrow=c(1,1))


###################################################
### chunk number 10: Monplot
###################################################
#line 161 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 150 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#161#"
par(mfrow=c(2,2))
plot(P,mfrow=NULL)
plot(Obs,pch=16,cex=2,xlim=c(0,400),ylim=c(0,0.15),
     xlab="mg COD/l",ylab="1/hr",main="best-fit")
lines(Model(P$par,x))
par(mfrow=c(1,1))
#line 162 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 11: 
###################################################
#line 182 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
Covar   <- sP$cov.scaled * 2.4^2/2
s2prior <- sP$modVariance

print(system.time(
MCMC <- modMCMC(f=Residuals,p=P$par,jump=Covar,niter=3000,
                var0=s2prior,wvar0=1,lower=c(0,0))
))


###################################################
### chunk number 12: 
###################################################
#line 193 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
print(system.time(
MCMC <- modMCMC(f=Residuals,p=P$par,jump=Covar,niter=3000, ntrydr=3,
                var0=s2prior,wvar0=1,updatecov=100,lower=c(0,0))
))
MCMC$count


###################################################
### chunk number 13: Monmcmc
###################################################
#line 201 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
plot(MCMC,Full=TRUE)


###################################################
### chunk number 14: Monmcmc
###################################################
#line 207 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 201 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#207#"
plot(MCMC,Full=TRUE)
#line 208 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 15: Monhist
###################################################
#line 216 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
hist(MCMC,Full=TRUE,col="darkblue")


###################################################
### chunk number 16: Monhist
###################################################
#line 222 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 216 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#222#"
hist(MCMC,Full=TRUE,col="darkblue")
#line 223 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 17: Monpairs
###################################################
#line 231 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
pairs(MCMC)


###################################################
### chunk number 18: Monpairs
###################################################
#line 237 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 231 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#237#"
pairs(MCMC)
#line 238 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 19: 
###################################################
#line 246 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
cor(MCMC$pars)
cov(MCMC$pars)
sP$cov.scaled


###################################################
### chunk number 20: 
###################################################
#line 255 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
MC <- as.mcmc(MCMC$pars)
raftery.diag(MC)


###################################################
### chunk number 21: cumu
###################################################
#line 260 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
cumuplot(MC)


###################################################
### chunk number 22: cumu
###################################################
#line 266 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 260 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#266#"
cumuplot(MC)
#line 267 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 23: 
###################################################
#line 280 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
sR<-sensRange(parInput=MCMC$pars,func=Model,x=1:375)


###################################################
### chunk number 24: Monsum
###################################################
#line 284 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
plot(summary(sR),quant=TRUE)
points(Obs)


###################################################
### chunk number 25: Monsum
###################################################
#line 291 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 284 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#291#"
plot(summary(sR),quant=TRUE)
points(Obs)
#line 292 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


###################################################
### chunk number 26: 
###################################################
#line 314 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
pset <- attributes(sR)$pset


###################################################
### chunk number 27: 
###################################################
#line 320 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
nout  <- nrow(sR)
sR2   <- sR
ivar  <- 3:ncol(sR)
error <- rnorm(nout,mean=0,sd=sqrt(MCMC$sig[pset]))
sR2[,ivar] <- sR2[,ivar] + error


###################################################
### chunk number 28: MonsumM
###################################################
#line 327 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
plot(summary(sR2),quant=TRUE)
points(Obs)


###################################################
### chunk number 29: MonsumM
###################################################
#line 334 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"
#line 327 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw#from line#334#"
plot(summary(sR2),quant=TRUE)
points(Obs)
#line 335 "d:/Rcompile/CRANpkg/local/2.12/FME/inst/doc/FMEother.Rnw"


